#include<iostream>
#include<bits/stdc++.h> 
using namespace std;
int main()
{
	int n,m;
	cin>>n;
	cin>>m;
	 vector<vector<int> > a( n , vector<int> (m)); 
	vector<int> kon(m);
	int t = -1;
	int sum = 0;
    
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			cin>>a[i][j];	
		}	
	}
	for(int i=0;i<m;i++)
		kon[i]=1;
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			if(a[i][j]==1)
			{
				if(sum!=0)
				{
					if(t==-1)
					{
						kon[j]+=sum;
						sum=0;
					}
					else
					{
						if(sum%2==0)
						{
							kon[t]+=sum/2;
							kon[j]+=sum/2;
							sum=0;
							t=-1;
						}
						else
						{
							kon[t]+=(sum-1)/2;
							kon[j]+=(sum-1)/2;
							sum=0;
							if(i%2==0)
							{
								kon[t]++;
							}
							else
							{
								kon[j]++;
							}
							t=-1;
						}
					}
				}
				if(j<m-1 && a[i][j+1]==0)
				{
					t=j;
				}
			}
			if(a[i][j]==0)
			{
				sum+=kon[j];
				kon[j]=0;
			}
		}
		if(t!=-1)
		{
			kon[t]+=sum;
			sum=0;
			t=-1;
		}
	}
	for(int i=0;i<m;i++)
		cout<<kon[i];
	return 0;
}